image: registry.gitlab.com/rilis/docker-ci:ci-latest

stages:
  - test
  - stats
  - docs

clang-format:
  stage: stats
  script:
  - find * -iname '*.hpp' -o -iname '*.cpp' | xargs clang-format -i -style=file
  - git status --porcelain > ../status.log
  - git diff
  - test ! -s ../status.log

cpplint:
  stage: stats
  script:
  - find * -iname '*.cpp' -o -iname '*.hpp' | xargs cpplint.py --linelength=120 --extensions=hpp,cpp --filter=-legal/copyright,-build/include_order,-build/c++11,+build/c++14,-runtime/references

doxygen:
  stage: docs
  script:
    - doxygen Doxyfile
  artifacts:
    expire_in: 1 week
    paths:
    - doxygen/html

coverage:
  stage: stats
  script:
  - hell --install -r "=" -r "RILI_DSDL_TESTS=ON" -r "RILI_DSDL_COVERAGE=ON" -i "CMAKE_BUILD_TYPE=Release" -i "CMAKE_CXX_STANDARD=11" -G "Ninja"
  - mkdir build
  - cd build
  - cmake ../ -G"Ninja" -DRILI_DSDL_TESTS=ON -DRILI_DSDL_COVERAGE=ON -DCMAKE_INSTALL_PREFIX=../.hell/install -DCMAKE_CXX_STANDARD=11
  - ninja install
  - ./rili-dsdl_tests
  - ./rili-dsdl-compiler CPP . "namespace=some_namespace"  < ../example/MyStructures.dsdl
  - cd ..
  - lcov --directory ./build/ --capture --output-file coverage.info
  - lcov --remove coverage.info '/usr/include/*' '*dsdl/tests/*' '*/.hell/*' -o coverage.info
  - genhtml coverage.info --output-directory coverage
  - lcov --list coverage.info
  artifacts:
    when: always
    expire_in: 1 day
    name: "$CI_JOB_NAME"
    paths:
      - coverage

valgrind:
  stage: stats
  script:
  - hell --install -r "=" -r "RILI_DSDL_TESTS=ON" -i "CMAKE_BUILD_TYPE=Debug" -i "CMAKE_CXX_STANDARD=11" -G "Ninja"
  - mkdir build
  - cd build
  - cmake ../ -G"Ninja" -DRILI_DSDL_TESTS=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_INSTALL_PREFIX=../.hell/install -DCMAKE_CXX_STANDARD=11
  - ninja install
  - valgrind --leak-check=full --show-leak-kinds=all --error-exitcode=123 ./rili-dsdl_tests
  - valgrind --leak-check=full --show-leak-kinds=all --error-exitcode=123 ./rili-dsdl-compiler CPP . "namespace=some_namespace"  < ../example/MyStructures.dsdl

test:
  stage: test
  script:
  - hell --install -r "=" -r "RILI_DSDL_TESTS=ON" -i "CMAKE_BUILD_TYPE=Release" -i "CMAKE_CXX_STANDARD=11" -G "Ninja"
  - mkdir build
  - cd build
  - cmake ../ -G"Ninja" -DRILI_DSDL_TESTS=ON -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=../.hell/install -DCMAKE_CXX_STANDARD=11
  - ninja install
  - ./rili-dsdl_tests
  - ./rili-dsdl-compiler CPP . "namespace=some_namespace"  < ../example/MyStructures.dsdl
  - cat DSDL.structures.hpp
  - cat DSDL.functions.hpp
